config/routes.rb
Rails.application.routes.draw do
  require 'sidekiq/web'
  require 'sidekiq/cron/web'
  mount Sidekiq::Web => '/sidekiq'

  get 'news/index'
  get 'feeds/generate'
	post 'feeds/create'
	post 'feeds/new'
  resources :feeds do
    member do
      resources :entries, only: [:index, :show]
    end
  end
  root 'news#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/entry.rb
class Entry < ApplicationRecord
  belongs_to :feed
  self.skip_time_zone_conversion_for_attributes = [:published]
end

app/models/feed.rb
class Feed < ApplicationRecord
  has_many :entries, dependent: :destroy
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/entries_controller.rb
class EntriesController < ApplicationController
  before_action :set_feed, only: :index

  def index
    @entries = @feed.entries.order('published desc')
  end

  def show
    @entry = Entry.find(params[:id])
  end

  private

  def set_feed
    @feed = Feed.find(params[:id])
  end
end

app/controllers/feeds_controller.rb
class FeedsController < ApplicationController
  before_action :set_feed, only: [:show, :edit, :update, :destroy]
  skip_before_action :verify_authenticity_token

  # GET /feeds
  # GET /feeds.json
  def index
    @feeds = Feed.all
    if params[:reload_single].present?
      FetchFeedJob.set(wait_until: Time.now + 1.seconds).perform_later(params[:reload_single])
      feed = Feed.where(id: params[:reload_single]).first
      redirect_to feeds_path, notice: "Feed #{feed.name} was successfully updated."
    end

    if params[:reload_all].present?
      FetchAllFeedsJob.set(wait_until: Time.now + 1.seconds).perform_later()
      redirect_to feeds_path, notice: "All feeds were successfully updated."
    end
  end

  def generate
    if params[:id].present?
      FetchFeedJob.set(wait_until: Time.now + 1.seconds).perform_later(params[:id])
    else
      FetchAllFeedsJob.set(wait_until: Time.now + 1.seconds).perform_later()
    end
    redirect_to feeds_path, notice: "Feed update was triggered."
  end

  # GET /feeds/1
  # GET /feeds/1.json
  def show
  end

  # GET /feeds/new
  def new
    @feed = Feed.new
  end

  # GET /feeds/1/edit
  def edit
  end

  # POST /feeds
  # POST /feeds.json
  def create
    @feed = Feed.new(feed_params)

    respond_to do |format|
      if @feed.save
        FetchFeedJob.set(wait_until: Time.now + 1.seconds).perform_later(@feed.id)
        format.html { redirect_to feeds_path, notice: 'Feed was successfully created.' }
        format.json { render :show, status: :created, location: @feed }
      else
        format.html { render :new }
        format.json { render json: @feed.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /feeds/1
  # PATCH/PUT /feeds/1.json
  def update
    respond_to do |format|
      if @feed.update(feed_params)
        format.html { redirect_to @feed, notice: 'Feed was successfully updated.' }
        format.json { render :show, status: :ok, location: @feed }
      else
        format.html { render :edit }
        format.json { render json: @feed.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /feeds/1
  # DELETE /feeds/1.json
  def destroy
    @feed.destroy
    respond_to do |format|
      format.html { redirect_to feeds_url, notice: 'Feed was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_feed
      @feed = Feed.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def feed_params
      params.require(:feed).permit(:name, :url, :description)
    end
end

app/controllers/news_controller.rb
class NewsController < ApplicationController
  # Extract information for for the construction of the aggregated news
  # feed page and its filtering form
  def index
    @feed_list = Feed.distinct(:name).select(:id, :name)
    @news = Feed.joins(:entries).select("feeds.name as feed, entries.*").order("entries.published desc")
		@news = @news.where("feeds.name like '#{params[:feed]}'") if params[:feed].present?
		@news = @news.where("entries.title like '#{params[:title]}'") if params[:title].present?
		@news = @news.where("entries.author like '#{params[:author]}'") if params[:author].present?
		@news = @news.where("entries.published >= '#{params[:timestamp_from]}'") if params[:timestamp_from].present?
		@news = @news.where("entries.published <= '#{params[:timestamp_to]}'") if params[:timestamp_to].present?
    @news = @news.paginate(page: params[:page], per_page:  (params[:items].present? ? params[:items] : 20))
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/entries_helper.rb
module EntriesHelper
end

app/helpers/feeds_helper.rb
module FeedsHelper
end

app/helpers/news_helper.rb
module NewsHelper
end

app/views/entries/index.html.erb
<h1>Entries</h1>
<div class="container">
  <% @entries.each do |entry| %>
    <div>
      <% unless entry.published.nil? %>
        <%= link_to entry.title, entry %> - <i>published: <%= time_ago_in_words(entry.published)%> ago.</i>
      <% else %>
        <%= link_to entry.title, entry %>
      <% end %>
    </div>
  <% end %>
</div>

app/views/entries/show.html.erb
<div class="container">
    <h3><%= link_to @entry.title, @entry.url %></h3>
    <i>
      published on <%= @entry.published %>
      <%= " by #{@entry.author}" unless @entry.author.nil? %>
    </i>
    <p>
      <%= @entry.content.html_safe %>
    </p>
</div>

app/views/feeds/_form.html.erb
<style>
  a, a:visited{
    color: white;
  }
</style>
<div class="container-fluid">
<%= form_with(model: feed, local: true, id: "feed_form") do |form| %>
  <% if feed.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(feed.errors.count, "error") %> prohibited this feed from being saved:</h2>

      <ul>
      <% feed.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="row">
    <div class="col-1"><%= form.label :name %></div>
    <div class="col-6"><%= form.text_field :name, class: "form-control" %></div>
  </div>

  <div class="row">
    <div class="col-1"><%= form.label :url %></div>
    <div class="col-6"><%= form.text_field :url, class: "form-control" %></div>
  </div>

  <div class="row">
    <div class="col-1"><%= form.label :description %></div>
    <div class="col-6"><%= form.text_area :description, class: "form-control" %></div>
  </div>

</div>
<br />
<% end %>
<button class="btn btn-primary" onclick="$('#feed_form').submit()">Save</button>
<%= link_to 'Back', feeds_path, class: "btn btn-danger" %>

app/views/feeds/edit.html.erb
<div class="container-fluid">
  <div class="header-container">
    <h3>Edit Feed</h3>
  </div>
  <br clear="both" />

  <%= render 'form', feed: @feed %>
</div>

app/views/feeds/index.html.erb
<div class="container-fluid" >
  <% unless notice.nil? %>
    <div class="alert alert-success" id="notice"><%= notice %></div>
  <% end %>
  <div class="header-container">
    <div class="header-label"><h3>Feeds</h3></div>
    <div class="header-buttons">
      <div class="btn-group" role="group">
        <%= link_to 'New Feed', new_feed_path, {class: "btn btn-primary"} %>
        <%= link_to 'Reload All Feeds', "#{feeds_generate_path}", {class: "btn btn-success"} %>
        <%= link_to 'Back to the news', news_index_path, {class: "btn btn-warning"} %>
      </div>

    </div>
  </div>
  <br clear="both" />
  <table class="table table-hover">
    <colgroup>
      <col />
      <col />
      <col />
      <col width="120px;"/>
    </colgroup>
    <thead>
      <tr>
        <th>Name</th>
        <th>Url</th>
        <th>Description</th>
        <th>Actions</th>
      </tr>
    </thead>

    <tbody>
      <% @feeds.each do |feed| %>
        <tr>
          <td><%= feed.name %></td>
          <td><%= feed.url %></td>
          <td><%= feed.description %></td>
          <td>
            <%= link_to '', edit_feed_path(feed), class: "fa fa-edit fa-success" %>
            <%= link_to '', "#{feeds_generate_path}?id=#{feed.id}", class: "fa fa-refresh fa-secondary" %>
            <%= link_to '', feed, class: "fa fa-trash fa-danger", method: :delete, data: { confirm: 'Are you sure?' } %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/feeds/new.html.erb
<div class="container-fluid">
	<h3>New Feed</h3>
	
	<%= render 'form', feed: @feed %>
</div>

app/views/feeds/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @feed.name %>
</p>

<p>
  <strong>Url:</strong>
  <%= @feed.url %>
</p>

<p>
  <strong>Description:</strong>
  <%= @feed.description %>
</p>

<%= link_to 'Edit', edit_feed_path(@feed) %> |
<%= link_to 'Back', feeds_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RssReader</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/news/index.html.erb
<div class="container-fluid">
  <div class="row">
    <div class="col-12">
    	<h3>Wellcome to your aggregated feed</h3>
      <h6>Here are the latest news</h6>
    </div>
	</div>

	<!-- Form to allow filtering of the aggregated feed -->
	<form action="<%= news_index_path %>" method="GET" id="filter-form">
  <div class="row">
    <div class="col-2">
			<div class="input-group input-group-sm mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text"><i class="fa fa-rss-square">&nbsp;</i>Feed:</span>
				</div>
				<input type="text" class="form-control" name="feed" id="feed" value="<%= (params[:feed].present? ? params[:feed] : nil) %>">
			</div>
		</div>
	
		<div class="col-2">
			<div class="input-group input-group-sm mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text"><i class="fa fa-tag">&nbsp;</i>Title:</span>
				</div>
				<input type="text" class="form-control" name="title" id="value" value="<%= (params[:title].present? ? params[:title] : nil) %>">
			</div>
		</div>

		<div class="col-2">
			<div class="input-group input-group-sm mb-3">
				<div class="input-group-prepend">
					<span class="input-group-text"><i class="fa fa-user-circle">&nbsp;</i>Author:</span>
				</div>
				<input type="text" class="form-control" name="author" id="author" value="<%= (params[:author].present? ? params[:author] : nil) %>">
			</div>
		</div>

		<div class="col-4">
			<div class="input-group input-group-sm mb3">
				<div class="input-group-prepend">
					<span class="input-group-text"><i class="fa fa-calendar">&nbsp;</i>Published:</span>
				</div>
				<input type='text' class="form-control dtp" name="timestamp_from" id="timestamp_from" value="<%= (params[:timestamp_from].present? ? params[:timestamp_from] : nil) %>"/>
				<input type='text' class="form-control dtp" name="timestamp_to" id="timestamp_to" value="<%= (params[:timestamp_to].present? ? params[:timestamp_to] : nil)%>"/>
			</div>
		</div>

		<div class="col-1">
			<div class="btn-group" role="group">
				<input type="submit" value="Filter" class="btn btn-primary btn-sm">
				<button id="clear-form" class="btn btn-danger btn-sm" >Clear</button>
			</div>
		</div>
	</form>

		<div class="col-1">
    	<%= link_to "Edit feeds", feeds_path, class: "btn btn-primary btn-sm" %>
		</div>

	</div>

	<!-- Aggregated feed display -->
	<div class="row">
    <div class="col-12">
      <table class="table table-hover">
        <tr>
          <th>Feed</th>
          <th>Title</th>
          <th>Author</th>
          <th>Published</th>
        </tr>
        <% @news.each do |entry| %>
          <tr>
            <td><%= entry.feed.html_safe unless entry.feed.nil?%></td>
            <td><%= link_to entry.title.html_safe, entry.url, target: :_blank %></td>
            <td><%= entry.author.html_safe unless entry.author.nil? %></td>
            <td><%= entry.published unless entry.published.nil? %> </td>
          </tr>
        <% end %>
      </table>
    </div>
	</div>

	<!-- Pagination display -->
  <div class="row">
    <div class="col-12">
      <div class="pagination">
        <%= will_paginate @news, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
      </div>
    </div>
  </div>
</div>

<script type="text/javascript">
	// Initialize the date-time picker controls
	$( document ).ready(function() {
    $('.dtp').datetimepicker({format: 'YYYY-MM-DD HH:mm'});
	});

	// Clear the filtering form on button click and resubmit it with empty values to clear the results too
	$("#clear-form").click(function(event){
		event.preventDefault();
		$("#feed").val("");
		$("#title").val("");
		$("#author").val("");
		$("#timestamp_from").val("");
		$("#timestamp_to").val("");
		$("#filter-form").submit();
	}) ;
	
</script>